﻿/*
 
C# Example application for the Top16-II IO board

04-July-2017 Created
 

 */
 

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

using Top16II;   // Dot Net library included in your project using 'Add Reference'

namespace ExampleApplication
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            // populate the serial number list with all connected Top16 II boards
            //     
            comboBox1.Items.AddRange(top16ioII.getSerialNumbers().ToArray());

            if (comboBox1.Items.Count > 0)
            {
                comboBox1.SelectedIndex = 0;
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            String theBoard = comboBox1.SelectedItem.ToString();
            uint handle = top16ioII.OpenTOP16DIOBoard(theBoard);

            if (handle >= 0)
            {

                // we opened a board sucessfully
                //

                textBox1.Clear();

                for (int i = 1; i <= 8; i++)
                {
                    textBox1.Text += "Read input " + i + " : " + top16ioII.readAnalogInput(handle, i).ToString("0.00") + "\t milliVolts \r\n";
                    
                }

                top16ioII.CloseTop16DIOBoard(handle);


            }


        }

        private void setAnOutput(byte mask, byte newState)
        {
            String theBoard = comboBox1.SelectedItem.ToString();
            uint handle = top16ioII.OpenTOP16DIOBoard(theBoard);

            if (handle >= 0)
            {
                // we opened a board sucessfully
                //
                top16ioII.SetOutputs(handle, mask, newState);

                top16ioII.CloseTop16DIOBoard(handle);

            }
        }

        private void checkBoxDout1_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBoxDout1.Checked)
            {
                setAnOutput(0x01, 0x01);
            }
            else
            {
                setAnOutput(0x01, 0x00);
            }
        }

        private void checkBoxDout2_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBoxDout2.Checked)
            {
                setAnOutput(0x02, 0x02);
            }
            else
            {
                setAnOutput(0x02, 0x00);
            }
        }

        private void checkBoxDout3_CheckedChanged(object sender, EventArgs e)
        {

            if (checkBoxDout3.Checked)
            {
                setAnOutput(0x04, 0x04);
            }
            else
            {
                setAnOutput(0x04, 0x00);
            }
        }

        private void checkBoxDout4_CheckedChanged(object sender, EventArgs e)
        {

            if (checkBoxDout4.Checked)
            {
                setAnOutput(0x08, 0x08);
            }
            else
            {
                setAnOutput(0x08, 0x00);
            }
        }

        private void checkBoxDout5_CheckedChanged(object sender, EventArgs e)
        {

            if (checkBoxDout5.Checked)
            {
                setAnOutput(0x10, 0x10);
            }
            else
            {
                setAnOutput(0x10, 0x00);
            }
        }

        private void checkBoxDout6_CheckedChanged(object sender, EventArgs e)
        {

            if (checkBoxDout6.Checked)
            {
                setAnOutput(0x20, 0x20);
            }
            else
            {
                setAnOutput(0x20, 0x00);
            }
        }

        private void checkBoxDout7_CheckedChanged(object sender, EventArgs e)
        {

            if (checkBoxDout7.Checked)
            {
                setAnOutput(0x40, 0x40);
            }
            else
            {
                setAnOutput(0x40, 0x00);
            }
        }

        private void checkBoxDout8_CheckedChanged(object sender, EventArgs e)
        {

            if (checkBoxDout8.Checked)
            {
                setAnOutput(0x80, 0x80);
            }
            else
            {
                setAnOutput(0x80, 0x00);
            }
        }
    }
}
